package com.example.store5

import android.os.Bundle
import androidx.fragment.app.Fragment
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup

import com.example.store5.databinding.FragmentFirstBinding
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.Dispatchers

import kotlinx.coroutines.launch
import org.mobilenativefoundation.store.store5.Fetcher
import org.mobilenativefoundation.store.store5.StoreBuilder
import org.mobilenativefoundation.store.store5.StoreReadRequest
import org.mobilenativefoundation.store.store5.StoreWriteRequest
import org.mobilenativefoundation.store.store5.Updater
import org.mobilenativefoundation.store.store5.UpdaterResult

/**
 * A simple [Fragment] subclass as the default destination in the navigation.
 */
class FirstFragment : Fragment() {

    private var _binding: FragmentFirstBinding? = null

    // This property is only valid between onCreateView and
    // onDestroyView.
    private val binding get() = _binding!!

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {

        _binding = FragmentFirstBinding.inflate(inflater, container, false)
        return binding.root

    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        binding.buttonFirst.setOnClickListener {
            CoroutineScope(Dispatchers.IO).launch {
                store.write(StoreWriteRequest.of("a", "====TEST===="))
            }
        }

        binding.buttonFirst2.setOnClickListener {
            CoroutineScope(Dispatchers.IO).launch {
                store.stream<String>(StoreReadRequest.cached("a", false) ).collect {
                    System.out.println(it)
                }
            }
        }

        CoroutineScope(Dispatchers.IO).launch {
            store.stream<String>(StoreReadRequest.cached("a", false) ).collect {
                System.out.println(it)
            }
        }

    }

    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }

    private val store = StoreBuilder.from<String,String,String>(Fetcher.of { k -> "======${k}======" })
        .build(
            Updater.by<String,String,String>({ _, v ->
                UpdaterResult.Success.Typed(v) })
        )
}